﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace NLScC.View
{
    /// <summary>
    /// Interaktionslogik für ManagedApplicationView.xaml
    /// </summary>
    public partial class ManagedApplicationView : UserControl
    {
        public static readonly DependencyProperty AppWidthProperty = DependencyProperty.Register("AppWidth", typeof(int), typeof(ManagedApplicationView), new PropertyMetadata());
        public static readonly DependencyProperty AppHeightProperty = DependencyProperty.Register("AppHeight", typeof(int), typeof(ManagedApplicationView), new PropertyMetadata());
        public static readonly DependencyProperty AppFontSizeProperty = DependencyProperty.Register("AppFontSize", typeof(int), typeof(ManagedApplicationView), new PropertyMetadata());
        public static readonly DependencyProperty ImageAlignmentProperty = DependencyProperty.Register("ImageAlignment", typeof(HorizontalAlignment), typeof(ManagedApplicationView), new PropertyMetadata());
        public static readonly DependencyProperty ImageSizeProperty = DependencyProperty.Register("ImageSize", typeof(int), typeof(ManagedApplicationView), new PropertyMetadata());


        public int AppWidth
        {
            get { return (int)GetValue(AppWidthProperty); }
            set { SetValue(AppWidthProperty, value); }
        }

        public int AppHeight
        {
            get { return (int)GetValue(AppHeightProperty); }
            set { SetValue(AppHeightProperty, value); }
        }
        public int AppFontSize
        {
            get { return (int)GetValue(AppFontSizeProperty); } 
            set { SetValue(FontSizeProperty, value); }
        }
        public HorizontalAlignment ImageAlignment
        {
            get { return (HorizontalAlignment)GetValue(ImageAlignmentProperty); }
            set { SetValue(ImageAlignmentProperty, value); }
        }
        public int ImageSize
        {
            get { return (int)GetValue(ImageSizeProperty); }
            set { SetValue(ImageSizeProperty, value); }
        }



        public ManagedApplicationView()
        {
            InitializeComponent();
        }
    }
}
