﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NLScC.model;
using NLScC.Command;
using System.ComponentModel;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows;

namespace NLScC.ViewModel
{



    public class MemberAdminModelView : NotifyBase
    {
        private string _parent;
        public string Parent
        {
            get { return _parent; }
            set { SetField(ref _parent, value); }
        }


        public ICommand NewCommand { get; internal set; }
        public ICommand DeleteCommand { get; internal set; }
        public ICommand ApplyChangesCommand { get; internal set; }

        private void InitializeCommands()
        {
            NewCommand = new RelayCommand(AddNewExecute);
            DeleteCommand = new RelayCommand(DeleteExeecute, DeleteCanExecute);
            ApplyChangesCommand = new RelayCommand(ApplyChanges);
        }

        private async void ApplyChanges(object obj)
        {
            await Task.Run(() => Writer.WriteFile(_memberFile, _members,"memberadmin"));
            LogConsole.Log("MasterFile <Members.nlscc> erfolgreich geändert");
        }

        private bool DeleteCanExecute(object obj)
        {
            return _members.Count > 0;
        }

        private void DeleteExeecute(object obj)
        {
            _members.Remove((NLScC.model.NLSMember)MemberView.CurrentItem);
        }

        private void AddNewExecute(object obj)
        {
            NLSMember m = new NLSMember("Mustermann", "Max", "99999", "max.mustermann@muster.de", NLSUnit.Meldestelle);
            _members.Add(m);
            _memberView.MoveCurrentTo(m);
        }

        public void Refresh()
        {
            MemberView.Refresh();
        }


        private string _teamDirectory = AppSettings.TeamDirectory;
        private string _memberFile;
        private NLSMemberCollection _members;
        private ListCollectionView _memberView;
        public ListCollectionView MemberView
        {
            get { return _memberView; }
        }


        public MemberAdminModelView()
        {
            _parent = "DialogWindow";
            _memberFile = System.IO.Path.Combine(_teamDirectory, @"members.nlscco");
            InitializeCommands();
            _members = new NLSMemberCollection();
            LoadFileFromDisk();
            _memberView = new ListCollectionView(_members);
            _memberView.GroupDescriptions.Add(new PropertyGroupDescription("Unit"));
            _memberView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Unit", System.ComponentModel.ListSortDirection.Ascending));
            _memberView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Lastname", System.ComponentModel.ListSortDirection.Ascending));
            _memberView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Prename", System.ComponentModel.ListSortDirection.Ascending));

        }

        private void LoadFileFromDisk()
        {
            if (System.IO.File.Exists(_memberFile))
            {
                _members = (NLSMemberCollection)Reader.ReadFile(_memberFile, _members, "member");
            }
            else
            {
                LogConsole.Log("Die MasterFile <Members.nlscc> konnte nicht gefunden werden. Sie wird beim Speichern neu erstellt", LogConsole.LogLevel.Warning);
            }
        }
    }
}
