﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace NLScC.dialog
{
    /// <summary>
    /// Interaktionslogik für AddAppDialog.xaml
    /// </summary>
    public partial class AddAppDialog : Window
    {
        public AddAppDialog()
        {
            InitializeComponent();
        }

        public AddAppDialog(bool comboBoxUsage, List<string> grouplist) : this()
        {
            if (comboBoxUsage)
            {
                GroupInsert.Visibility = Visibility.Visible;
                GroupInsertText.Visibility = Visibility.Visible;
                GroupBox.Visibility = Visibility.Visible;
            }

            if(grouplist != null)
            {
                for (int i = 0; i < grouplist.Count; i++)
                {
                    GroupBox.Items.Add(grouplist.ElementAt(i));
                }
                GroupBox.SelectedIndex = 0;
            }
        }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(AppName.Text) && !string.IsNullOrEmpty(AppPath.Text))
            {
                this.DialogResult = true;
            }
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }

        private void GroupBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            GroupInsert.Text = GroupBox.SelectedItem.ToString();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.OpenFileDialog dialog = new System.Windows.Forms.OpenFileDialog();
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                AppPath.Text = dialog.FileName;
                if (string.IsNullOrEmpty(AppName.Text))
                {
                    AppName.Text = dialog.FileName.Substring(dialog.FileName.LastIndexOf('\\') + 1);
                }
            }
        }
    }
}
