﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Xml;

namespace NLScC.model
{
    public static class Reader
    {
        public static object ReadFile(string pathToRead, object objectToRead, string tempName)
        {
            object obj;
            FileInfo gzipFileName = new FileInfo(pathToRead);

            using (FileStream fileToDecompressAsStream = gzipFileName.OpenRead())
            {
                string decompressedFile = @"c:\temp\decomp" + tempName +  ".txt";
                using (FileStream decompressedStream = File.Create(decompressedFile))
                {
                    using (GZipStream decompressionStream = new GZipStream(fileToDecompressAsStream, CompressionMode.Decompress))
                    {
                        try
                        {
                            decompressionStream.CopyTo(decompressedStream);
                        }
                        catch (Exception e)
                        {
                            MessageBox.Show(e.Message);
                        }
                    }
                }


                using (XmlReader reader = XmlReader.Create(decompressedFile))
                {
                    var serializer = new DataContractSerializer(objectToRead.GetType());
                    obj = serializer.ReadObject(reader);
                }

                File.Delete(decompressedFile);
            }
            return obj;
        }
    }
}
