﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Xml;

namespace NLScC.model
{
    public static class Writer
    {
        public static void WriteFile(string pathToWrite, object objectToWrite, string tempName)
        {
            string temp = @"c:\temp\gz.txt";

            var ser = new DataContractSerializer(objectToWrite.GetType());
            using (XmlWriter writer = XmlWriter.Create(temp))
            {
                ser.WriteObject(writer, objectToWrite);
            }

            FileInfo fileToBeZipped = new FileInfo(temp);
            FileInfo gzipFileName = new FileInfo(pathToWrite);

            using (FileStream fileToBeZippedAsStream = fileToBeZipped.OpenRead())
            {
                using (FileStream gzipTargetAsStream = gzipFileName.Create())
                {
                    using (GZipStream gzipStream = new GZipStream(gzipTargetAsStream, CompressionMode.Compress))
                    {
                        try
                        {
                            fileToBeZippedAsStream.CopyTo(gzipStream);
                        }
                        catch(Exception e)
                        {
                            MessageBox.Show(e.Message);
                        }
                    }
                }
            }

            System.IO.File.Delete(temp);

        }


        public static void WriteFileForCollection(string pathToWrite, object collection, object collectionTypes)
        {
            string temp = @"c:\temp\gz.txt";

            var ser = new DataContractSerializer(collection.GetType());
            using (XmlWriter writer = XmlWriter.Create(temp))
            {
                ser.WriteObject(writer, collection);
            }

            FileInfo fileToBeZipped = new FileInfo(temp);
            FileInfo gzipFileName = new FileInfo(pathToWrite);

            using (FileStream fileToBeZippedAsStream = fileToBeZipped.OpenRead())
            {
                using (FileStream gzipTargetAsStream = gzipFileName.Create())
                {
                    using (GZipStream gzipStream = new GZipStream(gzipTargetAsStream, CompressionMode.Compress))
                    {
                        try
                        {
                            fileToBeZippedAsStream.CopyTo(gzipStream);
                        }
                        catch (Exception e)
                        {
                            MessageBox.Show(e.Message);
                        }
                    }
                }
            }

            System.IO.File.Delete(temp);
        }
    }
}
